<template>
  <div class="app-container">
    <el-form :model="queryParams" @submit.native.prevent ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item :label="$t('成品物料号')" prop="itemCode">
        <el-input v-model="queryParams.itemCode" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item :label="$t('成品物名称')" prop="itemName">
        <el-input v-model="queryParams.itemName" clearable @keyup.enter.native="handleQuery" />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('common.search') }}</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('common.reset') }}</el-button>
      </el-form-item>
    </el-form>
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
          v-hasPermi="['mes:pro:productionSolution:add']">{{$t('新增')}}</el-button>
      </el-col>
    </el-row>
    <el-table v-loading="loading" :data="productionSolutionList" row-key="productionSolutionId" default-expand-all>
      <el-table-column :label="$t('生产版本编码')" prop="productionSolutionCode">
        <template slot-scope="scope">
          <el-button size="mini" type="text" @click="handleView(scope.row)"
            v-hasPermi="['pro:productionSolutionCode:query']">{{ scope.row.productionSolutionCode }}</el-button>
        </template>
      </el-table-column>
      <el-table-column :label="$t('产品版本名称')" align="center" prop="productionSolutionName" :show-overflow-tooltip="true" />
      <el-table-column :label="$t('成品物料编码')" align="center" prop="itemCode" />
      <el-table-column :label="$t('成品物料名称')" align="center" prop="itemName" />
      <el-table-column :label="$t('创建人')" align="center" prop="createBy" />
      <el-table-column :label="$t('创建时间')" align="center" prop="createTime" />
      <el-table-column :label="$t('修改人')" align="center" prop="updateBy" />
      <el-table-column :label="$t('修改时间')" align="center" prop="updateTime" />
      <el-table-column :label="$t('common.remark')" align="center" prop="remark" />
      <!-- <el-table-column :label="$t('common.status')" align="center" width="100" prop="status">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.production_solution_status"
            :value="scope.row.status"
          />
        </template>
      </el-table-column> -->

      <!-- <el-table-column :label="$t('common.remark')" align="center" prop="usageName"  width="180"/> -->
      <el-table-column
        :label="$t('common.option')"
        width="200px"
        align="center"
        fixed="right"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['pro:productionSolution:edit']"
            >{{ $t('common.edit') }}</el-button
          >
          <el-button size="mini" type="text" icon="el-icon-delete"
            @click="handleDelete(scope.row)" v-hasPermi="['mes:pro:productionSolution:remove']">{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
      @pagination="getList" />
  </div>
</template>

<script>


import {
  //   listPrototypeRequest,
  //   getPrototypeRequest,
  //   delPrototypeRequest,
  //   addPrototypeRequest,
  //   updatePrototypeRequest,
  //   dofinish,
  listProductionSolution,
  delProductionSolution,
} from "@/api/mes/pro/productionSolution";
import ItemSelect from "@/components/itemSelect/single.vue";
import ClientSelect from "@/components/clientSelect/single.vue";
import VendorSelect from "@/components/vendorSelect/single.vue";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "PrototypeRequest",
  dicts: [
    "mes_pr_status",
    "mes_prototypeRequest_sourcetype",
    "mes_prototypeRequest_type",
    "production_solution_status",
  ],
  components: {
    Treeselect,
    ItemSelect,
    ClientSelect,
    VendorSelect,
  },
  data() {
    return {
      //自动生成编码
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 显示搜索条件
      showSearch: true,
      // 非单个禁用
      single: true,
      // 总条数
      total: 0,
      // 非多个禁用
      multiple: true,
      // 生产工单表格数据
      prototypeRequestList: [],
      // 生产工单树选项
      prototypeRequestOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        productionSolutionId: null, // 可以查简称与英文名
        productionSolutionCode: null,
        productionSolutionName: null,
        statsu: "PREPARE",
        itemId: null,
        routeId: null,
        usageId: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      },
      options: [
        { value: "PREPARE", label: this.$t('待确认') },
        { value: "FINISH", label: this.$t('已完成') },
      ],
      usageNames: [
        { value: this.$t('打样'), label: this.$t('打样') },
        { value: this.$t('量产'), label: this.$t('量产') },
        { value: this.$t('销售'), label: this.$t('销售') },
        { value: this.$t('特定'), label: this.$t('特定') },
      ],
      productionSolutionList: [],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        // prototypeRequestCode: [
        //   { required: true, message: "工单编码不能为空", trigger: "blur" }
        // ],
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询生产工单列表 */
    getList() {
      this.loading = true;
      listProductionSolution(this.queryParams).then((response) => {
        this.productionSolutionList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        productionSolutionId: null,
        productionSolutionCode: null,
        productionSolutionName: null,
        itemId: null,
        routeId: null,
        usageId: null,
        remark: null,
        createBy: null,
        createTime: null,
        updateBy: null,
        updateTime: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      // 跳转到申请单界面
      this.$router.push("/mes/pro/productionSolution/apply");
      return;
    },
    // 查询明细按钮操作
    handleView(row) {
      this.reset();
      const productionSolutionId = row.productionSolutionId || this.ids;
      this.$router.push(
        "/mes/pro/productionSolution/info?productionSolutionId=" +
        productionSolutionId
      );
      // getprototypeRequest(prototypeRequestId).then((response) => {
      //   this.form = response.data;
      //   this.open = true;
      //   this.title = "查看工单信息";
      //   this.optType = "view";
      // });
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const productionSolutionId = row.productionSolutionId || this.ids;
      this.$router.push(
        "/mes/pro/productionSolution/edit?productionSolutionId=" +
        productionSolutionId
      );
      // getPrototypeRequest(prototypeRequestId).then((response) => {
      //   // this.form = response.data;
      //   // this.open = true;
      //   // this.title = "修改生产工单";
      //   // this.optType="edit";
      //   // 跳转修改
      // });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal
        .confirm(this.$t('是否确认删除编号为"') + row.productionSolutionCode + this.$t('"的生产版本？'))
        .then(function () {
          return delProductionSolution(row.productionSolutionId);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t('common.del_success'));
        })
        .catch(() => { });
    },

    handleSelectProduct() {
      this.$refs.itemSelect.showFlag = true;
    },
    handleSelectClient() {
      this.$refs.clientSelect.showFlag = true;
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download(
        "mes/pro/prototypeRequest/export",
        {
          ...this.queryParams,
        },
        this.$t('打样申请单_{0}.xlsx', [new Date().getTime()])
      );
    },

    // 审批
    handleFinish(row) {
      row.prototypeRequestStatus = 1;
      this.$modal
        .confirm(this.$t('确认通过样品申请单？一旦完成，此工单将无法继续修改'))
        .then(function () {
          return dofinish(row); //完成申请单审批
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess(this.$t('审批成功'));
        })
        .catch(() => { });
    },
    // 生成制作单
    generatea(row) {
      // 跳转到制作单界面
      const prototypeRequestId = row.prototypeRequestId || this.ids;
      this.$router.push(
        "/mes/pro/prototypeMake/apply?prototypeRequestId=" + prototypeRequestId
      );
      return;
    },
  },
};
</script>
